﻿Imports System.Threading

Public Class RemoteReg
    Public Class RemoteRegResults
        Public Success As Boolean
        Public Value As String
    End Class
    Public Event Completed(ByVal sender As RemoteReg, ByVal res As RemoteRegResults)
    Public MachineName As String

    Public Sub New(ByVal ComputerName As String)
        Me.MachineName = ComputerName
    End Sub

    Public Sub Start()
        Dim t As New Thread(AddressOf Worker)
        t.Start()
    End Sub

    Private Sub Worker()
        Dim MyReg As Microsoft.Win32.RegistryKey = Nothing
        Dim MyRegKey As Microsoft.Win32.RegistryKey = Nothing
        Dim suc As Boolean
        Dim val As String = ""
        Try
            MyReg = Microsoft.Win32.RegistryKey.OpenRemoteBaseKey(Microsoft.Win32.RegistryHive.LocalMachine, MachineName)
            MyRegKey = MyReg.OpenSubKey("SOFTWARE\Microsoft\Windows NT\CurrentVersion\Winlogon")
            val = MyRegKey.GetValue("DefaultUserName")
            MyRegKey.Close()
            MyReg.Close()
            suc = True
        Catch ex As Exception
            suc = False
        Finally
            If Not MyReg Is Nothing Then
                MyReg = Nothing
            End If
            If Not MyRegKey Is Nothing Then
                MyRegKey = Nothing
            End If
            Dim res As New RemoteRegResults
            res.Success = suc
            res.Value = val
            RaiseEvent Completed(Me, res)
        End Try
    End Sub

End Class
